Package com.ngrok.definitions

# Class EndpointSamlMutate.Builder

java.lang.Object
com.ngrok.definitions.EndpointSamlMutate.Builder

Enclosing class:
  EndpointSamlMutate

public static class EndpointSamlMutate.Builder extends Object
Builder class for `EndpointSamlMutate`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `EndpointSamlMutate.Builder`
  `allowIdpInitiated(boolean allowIdpInitiated)`
  If true, the IdP may initiate a login directly (e.g.
  `EndpointSamlMutate.Builder`
  `allowIdpInitiated(Optional<Boolean> allowIdpInitiated)`
  If true, the IdP may initiate a login directly (e.g.
  `EndpointSamlMutate.Builder`
  `authorizedGroups(List<String> authorizedGroups)`
  If present, only users who are a member of one of the listed groups may access the target endpoint.
  `EndpointSamlMutate.Builder`
  `authorizedGroups(Optional<List<String>> authorizedGroups)`
  If present, only users who are a member of one of the listed groups may access the target endpoint.
  `EndpointSamlMutate`
  `build()`
  Constructs the `EndpointSamlMutate` instance.
  `EndpointSamlMutate.Builder`
  `cookiePrefix(String cookiePrefix)`
  the prefix of the session cookie that ngrok sets on the http client to cache authentication.
  `EndpointSamlMutate.Builder`
  `cookiePrefix(Optional<String> cookiePrefix)`
  the prefix of the session cookie that ngrok sets on the http client to cache authentication.
  `EndpointSamlMutate.Builder`
  `enabled(boolean enabled)`
  `true` if the module will be applied to traffic, `false` to disable.
  `EndpointSamlMutate.Builder`
  `enabled(Optional<Boolean> enabled)`
  `true` if the module will be applied to traffic, `false` to disable.
  `EndpointSamlMutate.Builder`
  `forceAuthn(boolean forceAuthn)`
  If true, indicates that whenever we redirect a user to the IdP for authentication that the IdP must prompt the user for authentication credentials even if the user already has a valid session with the IdP.
  `EndpointSamlMutate.Builder`
  `forceAuthn(Optional<Boolean> forceAuthn)`
  If true, indicates that whenever we redirect a user to the IdP for authentication that the IdP must prompt the user for authentication credentials even if the user already has a valid session with the IdP.
  `EndpointSamlMutate.Builder`
  `idpMetadata(String idpMetadata)`
  The full XML IdP EntityDescriptor.
  `EndpointSamlMutate.Builder`
  `idpMetadata(Optional<String> idpMetadata)`
  The full XML IdP EntityDescriptor.
  `EndpointSamlMutate.Builder`
  `inactivityTimeout(long inactivityTimeout)`
  Integer number of seconds of inactivity after which if the user has not accessed the endpoint, their session will time out and they will be forced to reauthenticate.
  `EndpointSamlMutate.Builder`
  `inactivityTimeout(Optional<Long> inactivityTimeout)`
  Integer number of seconds of inactivity after which if the user has not accessed the endpoint, their session will time out and they will be forced to reauthenticate.
  `EndpointSamlMutate.Builder`
  `maximumDuration(Duration maximumDuration)`
  Integer number of seconds of the maximum duration of an authenticated session.
  `EndpointSamlMutate.Builder`
  `maximumDuration(Optional<Duration> maximumDuration)`
  Integer number of seconds of the maximum duration of an authenticated session.
  `EndpointSamlMutate.Builder`
  `nameidFormat(String nameidFormat)`
  Defines the name identifier format the SP expects the IdP to use in its assertions to identify subjects.
  `EndpointSamlMutate.Builder`
  `nameidFormat(Optional<String> nameidFormat)`
  Defines the name identifier format the SP expects the IdP to use in its assertions to identify subjects.
  `EndpointSamlMutate.Builder`
  `optionsPassthrough(boolean optionsPassthrough)`
  Do not enforce authentication on HTTP OPTIONS requests.
  `EndpointSamlMutate.Builder`
  `optionsPassthrough(Optional<Boolean> optionsPassthrough)`
  Do not enforce authentication on HTTP OPTIONS requests.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### enabled

    public EndpointSamlMutate.Builder enabled(boolean enabled)
    `true` if the module will be applied to traffic, `false` to disable. default `true` if unspecified
    Parameters:
      `enabled` - the value of the `enabled` parameter as a `boolean`
    Returns:
      this builder instance

  - ### enabled

    public EndpointSamlMutate.Builder enabled(Optional<Boolean> enabled)
    `true` if the module will be applied to traffic, `false` to disable. default `true` if unspecified
    Parameters:
      `enabled` - the value of the `enabled` parameter as a `boolean`, wrapped in an `Optional`
    Returns:
      this builder instance

  - ### optionsPassthrough

    public EndpointSamlMutate.Builder optionsPassthrough(boolean optionsPassthrough)
    Do not enforce authentication on HTTP OPTIONS requests. necessary if you are supporting CORS.
    Parameters:
      `optionsPassthrough` - the value of the `options_passthrough` parameter as a `boolean`
    Returns:
      this builder instance

  - ### optionsPassthrough

    public EndpointSamlMutate.Builder optionsPassthrough(Optional<Boolean> optionsPassthrough)
    Do not enforce authentication on HTTP OPTIONS requests. necessary if you are supporting CORS.
    Parameters:
      `optionsPassthrough` - the value of the `options_passthrough` parameter as a `boolean`, wrapped in an `Optional`
    Returns:
      this builder instance

  - ### cookiePrefix

    public EndpointSamlMutate.Builder cookiePrefix(String cookiePrefix)
    the prefix of the session cookie that ngrok sets on the http client to cache authentication. default is 'ngrok.'
    Parameters:
      `cookiePrefix` - the value of the `cookie_prefix` parameter as a `String`
    Returns:
      this builder instance

  - ### cookiePrefix

    public EndpointSamlMutate.Builder cookiePrefix(Optional<String> cookiePrefix)
    the prefix of the session cookie that ngrok sets on the http client to cache authentication. default is 'ngrok.'
    Parameters:
      `cookiePrefix` - the value of the `cookie_prefix` parameter as a `String`, wrapped in an `Optional`
    Returns:
      this builder instance

  - ### inactivityTimeout

    public EndpointSamlMutate.Builder inactivityTimeout(long inactivityTimeout)
    Integer number of seconds of inactivity after which if the user has not accessed the endpoint, their session will time out and they will be forced to reauthenticate.
    Parameters:
      `inactivityTimeout` - the value of the `inactivity_timeout` parameter as a `long`
    Returns:
      this builder instance

  - ### inactivityTimeout

    public EndpointSamlMutate.Builder inactivityTimeout(Optional<Long> inactivityTimeout)
    Integer number of seconds of inactivity after which if the user has not accessed the endpoint, their session will time out and they will be forced to reauthenticate.
    Parameters:
      `inactivityTimeout` - the value of the `inactivity_timeout` parameter as a `long`, wrapped in an `Optional`
    Returns:
      this builder instance

  - ### maximumDuration

    public EndpointSamlMutate.Builder maximumDuration(Duration maximumDuration)
    Integer number of seconds of the maximum duration of an authenticated session. After this period is exceeded, a user must reauthenticate.
    Parameters:
      `maximumDuration` - the value of the `maximum_duration` parameter as a `Duration`
    Returns:
      this builder instance

  - ### maximumDuration

    public EndpointSamlMutate.Builder maximumDuration(Optional<Duration> maximumDuration)
    Integer number of seconds of the maximum duration of an authenticated session. After this period is exceeded, a user must reauthenticate.
    Parameters:
      `maximumDuration` - the value of the `maximum_duration` parameter as a `Duration`, wrapped in an `Optional`
    Returns:
      this builder instance

  - ### idpMetadata

    public EndpointSamlMutate.Builder idpMetadata(String idpMetadata)
    The full XML IdP EntityDescriptor. Your IdP may provide this to you as a a file to download or as a URL.
    Parameters:
      `idpMetadata` - the value of the `idp_metadata` parameter as a `String`
    Returns:
      this builder instance

  - ### idpMetadata

    public EndpointSamlMutate.Builder idpMetadata(Optional<String> idpMetadata)
    The full XML IdP EntityDescriptor. Your IdP may provide this to you as a a file to download or as a URL.
    Parameters:
      `idpMetadata` - the value of the `idp_metadata` parameter as a `String`, wrapped in an `Optional`
    Returns:
      this builder instance

  - ### forceAuthn

    public EndpointSamlMutate.Builder forceAuthn(boolean forceAuthn)
    If true, indicates that whenever we redirect a user to the IdP for authentication that the IdP must prompt the user for authentication credentials even if the user already has a valid session with the IdP.
    Parameters:
      `forceAuthn` - the value of the `force_authn` parameter as a `boolean`
    Returns:
      this builder instance

  - ### forceAuthn

    public EndpointSamlMutate.Builder forceAuthn(Optional<Boolean> forceAuthn)
    If true, indicates that whenever we redirect a user to the IdP for authentication that the IdP must prompt the user for authentication credentials even if the user already has a valid session with the IdP.
    Parameters:
      `forceAuthn` - the value of the `force_authn` parameter as a `boolean`, wrapped in an `Optional`
    Returns:
      this builder instance

  - ### allowIdpInitiated

    public EndpointSamlMutate.Builder allowIdpInitiated(boolean allowIdpInitiated)
    If true, the IdP may initiate a login directly (e.g. the user does not need to visit the endpoint first and then be redirected). The IdP should set the `RelayState` parameter to the target URL of the resource they want the user to be redirected to after the SAML login assertion has been processed.
    Parameters:
      `allowIdpInitiated` - the value of the `allow_idp_initiated` parameter as a `boolean`
    Returns:
      this builder instance

  - ### allowIdpInitiated

    public EndpointSamlMutate.Builder allowIdpInitiated(Optional<Boolean> allowIdpInitiated)
    If true, the IdP may initiate a login directly (e.g. the user does not need to visit the endpoint first and then be redirected). The IdP should set the `RelayState` parameter to the target URL of the resource they want the user to be redirected to after the SAML login assertion has been processed.
    Parameters:
      `allowIdpInitiated` - the value of the `allow_idp_initiated` parameter as a `boolean`, wrapped in an `Optional`
    Returns:
      this builder instance

  - ### authorizedGroups

    public EndpointSamlMutate.Builder authorizedGroups(List<String> authorizedGroups)
    If present, only users who are a member of one of the listed groups may access the target endpoint.
    Parameters:
      `authorizedGroups` - the value of the `authorized_groups` parameter as a `List` of `String`
    Returns:
      this builder instance

  - ### authorizedGroups

    public EndpointSamlMutate.Builder authorizedGroups(Optional<List<String>> authorizedGroups)
    If present, only users who are a member of one of the listed groups may access the target endpoint.
    Parameters:
      `authorizedGroups` - the value of the `authorized_groups` parameter as a `List` of `String`, wrapped in an `Optional`
    Returns:
      this builder instance

  - ### nameidFormat

    public EndpointSamlMutate.Builder nameidFormat(String nameidFormat)
    Defines the name identifier format the SP expects the IdP to use in its assertions to identify subjects. If unspecified, a default value of `urn:oasis:names:tc:SAML:2.0:nameid-format:persistent` will be used. A subset of the allowed values enumerated by the SAML specification are supported.
    Parameters:
      `nameidFormat` - the value of the `nameid_format` parameter as a `String`
    Returns:
      this builder instance

  - ### nameidFormat

    public EndpointSamlMutate.Builder nameidFormat(Optional<String> nameidFormat)
    Defines the name identifier format the SP expects the IdP to use in its assertions to identify subjects. If unspecified, a default value of `urn:oasis:names:tc:SAML:2.0:nameid-format:persistent` will be used. A subset of the allowed values enumerated by the SAML specification are supported.
    Parameters:
      `nameidFormat` - the value of the `nameid_format` parameter as a `String`, wrapped in an `Optional`
    Returns:
      this builder instance

  - ### build

    public EndpointSamlMutate build()
    Constructs the `EndpointSamlMutate` instance.
    Returns:
      a new `EndpointSamlMutate`